<script setup>
  import Slider from '@vueform/slider';
  import { filter } from '~/directives/filter.js';

  const props = defineProps({
    dataName: {
      type: String,
      required: true
    }
  });
  const emit = defineEmits(["selection"]);

  const format = ((value) => { return `${value}€` } );

  function toggleRangeSelection(is_checked) {
    filter.price_filter.is_ranged = is_checked;
    filter.price_filter.has_changed = is_checked;
    if(is_checked) {
      filter.price_filter.range_value = [10, 90];
      filter.price_filter.is_open = false;
      filter.price_filter.is_free = false;
    }
  }
  function toggleIsOpen(is_checked) {
    filter.price_filter.is_open = is_checked;
    filter.price_filter.has_changed = is_checked;
    if(is_checked) {
      filter.price_filter.is_ranged = false;
      filter.price_filter.is_free = false;
    }
  }
  function toggleIsFree(is_checked) {
    filter.price_filter.is_free = is_checked;
    filter.price_filter.has_changed = is_checked;
    if(is_checked) {
      filter.price_filter.is_ranged = false;
      filter.price_filter.is_open = false;
    }
  }

</script>

<template>
  <form @submit.prevent="onSubmit">
    <div
      class="w-full flex flex-col bg-white rounded-filters-block-bottom space-y-2 p-6">
      <FormCheckbox
        :text="'Définir un intervalle de prix'"
        :id="'priceRange'"
        :checked="filter.price_filter.is_ranged"
        @checked="(checked) => { toggleRangeSelection(checked) }"
      />
      <div v-if="filter.price_filter.is_ranged" class="pt-8 pb-12">
        <Slider
          v-model="filter.price_filter.range_value"
          :format="format"
          tooltip-position="bottom"
          class="slider-las"
        />
      </div>
      <FormCheckbox
        :text="'Prix libre'"
        :id="'openPrice'"
        :checked="filter.price_filter.is_open"
        @checked="(checked) => { toggleIsOpen(checked) }"
      />
      <FormCheckbox
        :text="'Gratuit'"
        :id="'freePrice'"
        :checked="filter.price_filter.is_free"
        @checked="(checked) => { toggleIsFree(checked) }"
      />
  </div>  
  </form>
</template>

<style>
  @import '@vueform/slider/themes/default.css';
  
  /* styling range slider */
  .slider-las {
    --slider-bg: #ddd;
    --slider-connect-bg: #e58252;
    --slider-handle-bg: #e58252;
    --slider-handle-ring-color: #e58252;
  }
  .slider-touch-area {
    background-color: #e58252;
    border-radius: 32px;
  }
  .slider-tooltip {
    background-color: #e58252;
    border: none;
  }
  /* styling checkboxes */
  input[type="checkbox"] {
    /* Add if not using autoprefixer */
    -webkit-appearance: none;
    appearance: none;
    /* For iOS < 15 to remove gradient background */
    background-color: #fff;
    /* Not removed via appearance */
    margin: 0;
    font: inherit;
    color: currentColor;
    width: 1.15em;
    height: 1.15em;
    border: 0.15em solid currentColor;
    border-radius: 0.15em;
    transform: translateY(-0.075em);
    display: grid;
    place-content: center;
  }
  input[type="checkbox"]::before {
    content: "";
    width: 0.65em;
    height: 0.65em;
    transform: scale(0);
    transition: 120ms transform ease-in-out;
    box-shadow: inset 1em 1em var(--form-control-color);
    background-color: CanvasText;
  }
  input[type="checkbox"]:checked::before {
    transform: scale(1);
    background-color: #e58252;
  }
</style>